# 
# * 7.12 Передача аргументов декораторам
# 

'''
Подвиг 1. Вводится строка целых чисел через пробел. Напишите функцию,
которая преобразовывает эту строку в список чисел и возвращает их сумму.

Определите декоратор для этой функции, который имеет один параметр
start - начальное значение суммы. Примените декоратор со значением
start=5 к функции и вызовите декорированную функцию для введенной
строки s:
s = input()
Результат отобразите на экране.
Sample Input:
5 6 3 6 -4 6 -1
Sample Output:
26
'''

# def add_start(start = 0):
#     def f(func) :
#         def wrapper(*args, **kwargs):
#             return start + func(*args, **kwargs)
#         return wrapper
#     return f
# @add_start(start=5)
# def str_sum(s: str) -> int:
#     return sum(map(int, s.split()))

# s = input()
# print(str_sum(s))

'''
Подвиг 2. Объявите функцию, которая возвращает переданную ей строку в
нижнем регистре (с малыми буквами). 
Определите декоратор для этой функции, который имеет один параметр tag,
определяющий строку с названием тега и начальным значением "h1". Этот
декоратор должен заключать возвращенную функцией строку в тег tag и
возвращать результат.
Пример заключения строки "python" в тег h1: <h1>python</h1>
Примените декоратор со значением tag="div" к функции и вызовите декорированную функцию для введенной строки s:
s = input()
Результат отобразите на экране.
Sample Input:
Декораторы - это классно!
Sample Output:
<div>декораторы - это классно!</div>
'''
# def add_tag(tag:str = 'h1'):
#     def f(func):
#         def wrapper(*args, **kwargs):
#             return f'<{tag}>{func(*args, **kwargs)}</{tag}>'
#         return wrapper
#     return f

# @add_tag(tag='div')
# def low_str(s: str) -> str:
#     return s.lower()

# print(low_str(input()))

'''
Подвиг 3. Объявите функцию, которая принимает строку на кириллице и
преобразовывает ее в латиницу, используя следующий словарь для замены
русских букв на соответствующее латинское написание:
t = {'ё': 'yo', 'а': 'a', 'б': 'b', 'в': 'v', 'г': 'g', 'д': 'd', 'е': 'e', 'ж': 'zh',
     'з': 'z', 'и': 'i', 'й': 'y', 'к': 'k', 'л': 'l', 'м': 'm', 'н': 'n', 'о': 'o', 'п': 'p',
     'р': 'r', 'с': 's', 'т': 't', 'у': 'u', 'ф': 'f', 'х': 'h', 'ц': 'c', 'ч': 'ch', 'ш': 'sh',
     'щ': 'shch', 'ъ': '', 'ы': 'y', 'ь': '', 'э': 'e', 'ю': 'yu', 'я': 'ya'}
Функция должна возвращать преобразованную строку. Замены делать без
учета регистра (исходную строку перевести в нижний регистр - малые буквы). 
Определите декоратор с параметром chars и начальным значением " !?",
который данные символы преобразует в символ "-" и, кроме того, все
подряд идущие дефисы (например, "--" или "---") приводит к одному дефису.
Полученный результат должен возвращаться в виде строки.
Примените декоратор с аргументом chars="?!:;,. " к функции и вызовите декорированную функцию для введенной строки s:
s = input()
Результат отобразите на экране.
Sample Input:
Декораторы - это круто!
Sample Output:

dekoratory-eto-kruto-
'''
# t = {'ё': 'yo', 'а': 'a', 'б': 'b', 'в': 'v', 'г': 'g', 'д': 'd', 'е': 'e', 'ж': 'zh',
#      'з': 'z', 'и': 'i', 'й': 'y', 'к': 'k', 'л': 'l', 'м': 'm', 'н': 'n', 'о': 'o', 'п': 'p',
#      'р': 'r', 'с': 's', 'т': 't', 'у': 'u', 'ф': 'f', 'х': 'h', 'ц': 'c', 'ч': 'ch', 'ш': 'sh',
#      'щ': 'shch', 'ъ': '', 'ы': 'y', 'ь': '', 'э': 'e', 'ю': 'yu', 'я': 'ya'}

# # здесь продолжайте программу
# def rm_np(chars:str = " !?"):
#     def del_def(func):
#         def wrapper(*args, **kwargs):
#             res = ''
#             for c in func(*args, **kwargs):
#                 res += '-' if c in chars else c
#             while res.count('--'):
#                 res = res.replace('--', '-')
#             return res

#         return wrapper

#     return del_def

# @rm_np(chars="?!:;,. ")
# def translit(s: str) -> str:
#     s = s.lower()
#     return ''.join(t[c] if c in t else c for c in s)

# print(translit(input()))

'''
Подвиг 4. Объявите функцию с именем get_list и следующим описанием в
теле функции:
'Функция для формирования списка целых значений'
Сама функция должна формировать и возвращать список целых чисел, который
поступает на ее вход в виде строки из целых чисел, записанных через
пробел.

Определите декоратор, который выполняет суммирование значений из списка
этой функции и возвращает результат.
Внутри декоратора декорируйте переданную функцию get_list с помощью
команды @wraps (не забудьте сделать импорт: 
from functools import wraps).
Такое декорирование необходимо, чтобы исходная функция get_list
сохраняла свои локальные свойства: __name__ и __doc__.

Примените декоратор к функции get_list, но не вызывайте ее.
'''
from functools import wraps

def get_sum(func):
    @wraps(func)
    def wrapper(*args, **kwargs):
        return sum(func(*args, **kwargs))
    return wrapper
        
@get_sum
def get_list(s: str) -> list:
    """Функция для формирования списка целых значений"""
    return list(map(int,s.split()))

# test
# print(get_list(input()))